<?php

namespace Dac;

use Dac\Client\DACClient;
use Dac\Manager\NFT1155Manager;
use Dac\Manager\NFT721Manager;
use Dac\Manager\NFT998Manager;
use Dac\Manager\ToolManager;

class DACSDK
{
    public NFT721Manager $nft721;
    public NFT1155Manager $nft1155;
    public NFT998Manager $nft998;
    public ToolManager $toolManager;

    /**
     * @param string $configPath
     * @throws Exception\ConfigException
     * @throws Exception\DACException
     */
    public function __construct(string $configPath)
    {
        $dacClient = new DACClient($configPath);
        $this->nft721 = new NFT721Manager($dacClient);
        $this->nft1155 = new NFT1155Manager($dacClient);
        $this->nft998 = new NFT998Manager($dacClient);
        $this->toolManager = new ToolManager($dacClient);
    }


}