<?php

namespace Dac\Model;

use Cassandra\Map;

class AuthorizationView
{
    public string $resource_path;
    public Metadata $metadata;
    public string $resource_url;

    /**
     * @param string $resource_path
     * @param string $metadata
     * @param string $resource_url
     */
    public function __construct(string $resource_path, Metadata $metadata, string $resource_url)
    {
        $this->resource_path = $resource_path;
        $this->metadata = $metadata;
        $this->resource_url = $resource_url;
    }

    /**
     * @return string
     */
    public function getResourcePath(): string
    {
        return $this->resource_path;
    }

    /**
     * @param string $resource_path
     */
    public function setResourcePath(string $resource_path): void
    {
        $this->resource_path = $resource_path;
    }

    /**
     * @return Map
     */
    public function getRequestHead(): Map
    {
        return $this->request_head;
    }

    /**
     * @param Map $request_head
     */
    public function setRequestHead(Map $request_head): void
    {
        $this->request_head = $request_head;
    }

    /**
     * @return string
     */
    public function getSignedUrl(): string
    {
        return $this->signed_url;
    }

    /**
     * @param string $signed_url
     */
    public function setSignedUrl(string $signed_url): void
    {
        $this->signed_url = $signed_url;
    }

    /**
     * @return string
     */
    public function getResourceUrl(): string
    {
        return $this->resource_url;
    }

    /**
     * @param string $resource_url
     */
    public function setResourceUrl(string $resource_url): void
    {
        $this->resource_url = $resource_url;
    }

}