<?php

namespace Dac\Model;

class BatchMintData
{
    public string $startTokenID;
    public string $amount;
    public Metadata $tokenURI;

    /**
     * @param string $startTokenID
     * @param string $amount
     * @param Metadata $tokenURI
     */
    public function __construct(string $startTokenID, string $amount, Metadata $tokenURI)
    {
        $this->startTokenID = $startTokenID;
        $this->amount = $amount;
        $this->tokenURI = $tokenURI;
    }

    public function getStartTokenID()
    {
        return (int)$this->startTokenID;
    }

    public function getAmount()
    {
        return (int)$this->amount;
    }

    public function toString()
    {
        return json_encode($this);
    }

    /**
     * @return bool
     */
    public function isValid()
    {
        if ($this->startTokenID == "" || empty($this->amount) || empty($this->tokenURI)) {
            return false;
        }
        return true;
    }


}