<?php

namespace Dac\Model;

class Metadata
{
    public string $name;
    public int $category;
    public string $type;
    public string $description;
    public string $hash;
    public string $url;
    public array $properties;

    const MetaTypeImage = "image";
    const MetaTypeVideo = "video";
    const MetaTypeAudio = "audio";
    const MetaTypeA3D = "3d";

    public function __construct()
    {

    }

    /**
     * @return string
     */
    public function getName(): string
    {
        return $this->name;
    }

    /**
     * @param string $name
     */
    public function setName(string $name): void
    {
        $this->name = $name;
    }

    /**
     * @return int
     */
    public function getCategory(): int
    {
        return $this->category;
    }

    /**
     * @param int $category
     */
    public function setCategory(int $category): void
    {
        $this->category = $category;
    }

    /**
     * @return string
     */
    public function getType(): string
    {
        return $this->type;
    }

    /**
     * @param string $type
     */
    public function setType(string $type): void
    {
        $this->type = $type;
    }

    /**
     * @return string
     */
    public function getDescription(): string
    {
        return $this->description;
    }

    /**
     * @param string $description
     */
    public function setDescription(string $description): void
    {
        $this->description = $description;
    }

    /**
     * @return string
     */
    public function getHash(): string
    {
        return $this->hash;
    }

    /**
     * @param string $hash
     */
    public function setHash(string $hash): void
    {
        $this->hash = $hash;
    }

    /**
     * @return string
     */
    public function getUrl(): string
    {
        return $this->url;
    }

    /**
     * @param string $url
     */
    public function setUrl(string $url): void
    {
        $this->url = $url;
    }

    /**
     * @return array
     */
    public function getProperties(): array
    {
        return $this->properties;
    }

    /**
     * @param array $properties
     */
    public function setProperties(array $properties): void
    {
        $this->properties = $properties;
    }


    public function toString()
    {
        return json_encode($this);
    }

    /**
     * @param array $arr
     * @return void
     */
    public function loadFromArray(array $arr)
    {
        if (!empty($arr)) {
            $this->name = $arr["name"];
            $this->category = $arr["category"];
            $this->type = $arr["type"];
            $this->description = $arr["description"];
            $this->url = $arr["url"];
            $this->hash = $arr["hash"];
            if (!empty($arr["properties"])) {
                $this->properties = $arr["properties"];
            } else {
                $this->properties = array();
            }
        }
    }

}